#include <stdio.h>
#include <stdlib.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <stdbool.h>

#include "settings.h"

SDL_Texture* Setting_Texture;

SDL_Rect Settings_rect;
Slider BV;
Slider BS;
Slider BT;

bool Settings_IsInit=false;

void Settings_Initialize (SDL_Renderer* renderer) {
  BV.Scalar_rect = (SDL_Rect){.y=300,.x=590,.w=20,.h=100};
  BS.Scalar_rect = (SDL_Rect){.y=500,.x=590,.w=20,.h=100};
  BT.Scalar_rect = (SDL_Rect){.y=700,.x=590,.w=20,.h=100};
  BV.Bar_rect = (SDL_Rect){.y = 300,.x = 400 , .w=400, .h=100};
  BS.Bar_rect = (SDL_Rect){.y = 500,.x = 400, .w=400, .h=100};
  BT.Bar_rect = (SDL_Rect){.y = 700,.x = 400, .w=400, .h=100};
  Setting_Texture = IMG_LoadTexture(renderer, "assets/images/settings_title.png");
  Settings_rect = (SDL_Rect){.x = 800, .y = 180, .w=313, .h=100};
  Settings_IsInit = true;
}

void Settings_Draw (SDL_Renderer* renderer) {
  SDL_SetRenderDrawColor(renderer,255,255,255,255);
  SDL_RenderCopy(renderer, Setting_Texture, NULL, &Settings_rect);
  Draw_Slider(renderer,&BV);
  Draw_Slider(renderer,&BS);
  Draw_Slider(renderer,&BT);
}

void Settings_Deinitialize(){
  if(Settings_IsInit){
    SDL_DestroyTexture(Setting_Texture);
    Settings_IsInit=false;
  }
}

void Draw_Slider(SDL_Renderer* renderer,Slider* beta){
  SDL_RenderDrawRect(renderer,&beta->Bar_rect);
  int x,y;
  Uint32 Mousestate=SDL_GetMouseState(&x,&y);
  SDL_SetRenderDrawColor(renderer,255,255,255,255);
  if(y<=((beta->Scalar_rect.y)+100)&&y>=(beta->Scalar_rect.y)&&x<=800&&x>=400&&(Mousestate & SDL_BUTTON(SDL_BUTTON_LEFT))){
    SDL_RenderFillRect(renderer,&beta->Scalar_rect);
    SDL_RenderDrawRect(renderer,&beta->Scalar_rect);
    if(x>790){
      beta->Scalar_rect.x=780;
    }
    else if(x<410){
      beta->Scalar_rect.x=400;
    }
    else{
      beta->Scalar_rect.x=x-10;
    }
  }
  else{
    SDL_RenderDrawRect(renderer,&beta->Scalar_rect);
  }
}
